local CrashSkinCheck = CrashAddon.CrashSkinCheck
local JumpManager = CrashAddon.JumpManager

//another function ported from Emmette
local function DustSpawners(orimo, dist, airmo, watermo)
	if orimo.eflags & MFE_UNDERWATER or orimo.eflags & MFE_GOOWATER
		P_SpawnMobjFromMobj(orimo, dist, 0, 0, watermo)
		P_SpawnMobjFromMobj(orimo, dist * -1, 0, 0, watermo)
		P_SpawnMobjFromMobj(orimo, 0, dist, 0, watermo)
		P_SpawnMobjFromMobj(orimo, 0, dist * -1, 0, watermo)
	else
		P_SpawnMobjFromMobj(orimo, dist, 0, 0, airmo)
		P_SpawnMobjFromMobj(orimo, dist * -1, 0, 0, airmo)
		P_SpawnMobjFromMobj(orimo, 0, dist, 0, airmo)
		P_SpawnMobjFromMobj(orimo, 0, dist * -1, 0, airmo)
	end
end

local function DoubleJump(player)
	if not CrashSkinCheck(player)
		return
	end
	
	if not (player.pflags & PF_THOKKED)
		S_StartSound(player.mo, sfx_jump)
		JumpManager(player.mo, 7 * FRACUNIT)
		player.mo.state = S_PLAY_JUMP
		DustSpawners(player.mo, 25 * player.mo.scale, MT_ARIDDUST, 
				MT_MEDIUMBUBBLE)
		player.pflags = $ | PF_THOKKED
	end
end

//this makes crash jump higher if he jumps while crawling/sliding
local function SlideNCrouchJump(player)
	if not CrashSkinCheck(player)
		return
	end
	
	if (player.mo.state == S_PLAY_CLING or player.mo.state == S_PLAY_CLIMB or 
			player.mo.state == S_PLAY_GLIDE)
		P_DoJump(player, true)
		JumpManager(player.mo, 12 * FRACUNIT)
		player.height = skins[player.mo.skin].height
		player.normalspeed = skins[player.mo.skin].normalspeed
		player.crashban.slidetimer = 0
		return true
	end
end

//hooks
addHook("AbilitySpecial", DoubleJump)
addHook("JumpSpecial", SlideNCrouchJump)