freeslot("MT_AKUAKU", "S_AKU_IDLE","SPR_AKU_", "sfx_cshflp", "sfx_akuded", 
		"sfx_akuspn", "sfx_cshpew", "sfx_ashcsh", "sfx_cshxry", "sfx_cshngl", 
		"sfx_cshfrz", "sfx_crdrwn", "sfx_cshfal", "sfx_woah", "sfx_cshsld", 
		"sfx_cshspn")
sfxinfo[sfx_cshflp].caption = "Pre-slam"
sfxinfo[sfx_akuded].caption = "Aku-Aku got hit!"
sfxinfo[sfx_akuspn].caption = "Aku-Aku power up"
sfxinfo[sfx_cshpew].caption = "Flung'd!"
sfxinfo[sfx_ashcsh].caption = "Someone overcooked a marsupial"
sfxinfo[sfx_cshxry].caption = "How shocking..."
sfxinfo[sfx_cshngl].caption = "He's going towards the light"
sfxinfo[sfx_cshfrz].caption = "Frozen in space"
sfxinfo[sfx_crdrwn].caption = "Crash meets Davy Jones"
sfxinfo[sfx_cshfal].caption = "'HELP!'"
sfxinfo[sfx_woah].caption = "woah"
sfxinfo[sfx_cshsld].caption = "Sliding"
sfxinfo[sfx_cshspn].caption = "Tornado Spin"
states[S_AKU_IDLE] = {
	sprite = SPR_AKU_,
	frame = A,
	tics = 1,
	nextstate = S_AKU_IDLE,
	action = A_Custom3DRotate
}
mobjinfo[MT_AKUAKU] = {
	spawnstate = S_AKU_IDLE,
	spawnhealth = 1,
	seestate = S_AKU_IDLE,
	speed = 25,
	radius = 10*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOCLIP|MF_NOGRAVITY
}

//console command that swaps the functions of spin and custom 1 for controllers
COM_AddCommand("crash_consolemode", function(player, var)
	if var == "off" or var == 0
		player.crash_consolemode = false
		CONS_Printf(player, "Console mode is disabled")
	elseif var == "on" or var == 1
		player.crash_consolemode = true
		CONS_Printf(player, "Console mode is enabled")
	else
		CONS_Printf(player, "Console mode swaps the actions of the spin and " +
				"custom 1 buttons, useful for controller players.")
	end
end, COM_LOCAL)

//a function to make skinchecking easier
CrashAddon.CrashSkinCheck = function(player)
	if player.mo == nil
		return false
	end
	if player.mo.skin != "crashbandi"
		return false
	end
	return true
end

/*this function just makes different jumps easier to manage since they all share
the same setup, ported from Emmette's code*/
CrashAddon.JumpManager = function(mo, hight)
	/*this nerfs the jumps while underwater or in space so that the player 
	doesn't jump way higher underwater than on dry land*/
	if mo.eflags & MFE_UNDERWATER or mo.eflags & MFE_GOOWATER or 
			P_InSpaceSector(mo)
		hight = $ - ($ / 3)
	end
	P_SetObjectMomZ(mo, hight)
end

//this is ported from Emmette's code to make setting states easier
CrashAddon.StateSetter = function(mo, sstate)
	if mo.state != sstate
		mo.state = sstate
	end
end

//speed calculation because player.speed not be accurate
CrashAddon.SpeedCalc = function(player)
	return FixedHypot(player.mo.momx - player.cmomx, player.mo.momy - player.cmomy)
end

//a function that returns the button to check based on if console mode is on/off
CrashAddon.ActionButton = function(player)
	if player.crash_consolemode
		return BT_CUSTOM1
	else
		return BT_SPIN
	end
end

//this overrides the invincibility function in order to change the music
function A_Invincibility(actor, var1, var2)
	super(actor, var1, var2)
	if actor.target.skin == "crashbandi"
		P_PlayJingleMusic(actor.target.player, "CSHINV", 0, false, JT_INV)
	end
end