local CrashSkinCheck = CrashAddon.CrashSkinCheck
local StateSetter = CrashAddon.StateSetter
local SpeedCalc = CrashAddon.SpeedCalc
local ActionButton = CrashAddon.ActionButton

local function CrawlAndSlide(player)
	if not CrashSkinCheck(player)
		return
	end
	
	//this resets the height changes made by crawling and sliding
	if not (player.cmd.buttons & ActionButton(player)) and 
			player.crashban.slidetimer <= 0
		player.height = skins[player.mo.skin].height
	end
	//this handles what happens when crash hits a spring while crawling/sliding
	if P_IsObjectOnGround(player.mo) and (player.cmd.buttons & 
			ActionButton(player) or player.crashban.slidetimer > 0) and 
			player.mo.eflags & MFE_SPRUNG
		player.mo.state = S_PLAY_ROLL
		player.pflags = $ | PF_SPINNING
		player.crashban.slidetimer = 0
	end
	//this makes Crash crawl or start sliding
	if player.cmd.buttons & ActionButton(player) and
			(P_IsObjectOnGround(player.mo) or player.mo.eflags & 
			MFE_JUSTHITFLOOR)
		if player.mo.state != S_PLAY_ROLL
			player.height = player.spinheight
			if player.normalspeed != 5 * FRACUNIT and SpeedCalc(player) > 
					player.mo.scale
				if player.crashban.slidetimer <= 0 and player.mo.state != 
						S_PLAY_GLIDE
					P_InstaThrust(player.mo, player.drawangle, 
							player.normalspeed + 15 * player.mo.scale)
					player.powers[pw_strong] = STR_ANIM|STR_WALL|STR_PUNCH
					player.mo.state = S_PLAY_GLIDE
					S_StartSound(player.mo, sfx_cshsld)
					player.crashban.slidetimer = TICRATE / 2
				end
			else
				player.normalspeed = 5 * FRACUNIT
				if player.mo.momx == player.cmomx and player.mo.momy == 
						player.cmomy
					StateSetter(player.mo, S_PLAY_CLING)
				else
					StateSetter(player.mo, S_PLAY_CLIMB)
				end
			end
		end
	else
		if player.mo.state == S_PLAY_CLING
			player.mo.state = S_PLAY_STND
		elseif player.mo.state == S_PLAY_CLIMB
			player.mo.state = S_PLAY_WALK
		end
		player.normalspeed = skins[player.mo.skin].normalspeed
	end
	//this handles what happens during the slide and after
	if player.crashban.slidetimer > 0
		player.pflags = $ | PF_STASIS
		P_SpawnSkidDust(player, 10 * player.mo.scale)
		player.crashban.slidetimer = $ - 1
	elseif player.mo.state == S_PLAY_GLIDE
		if player.cmd.buttons & ActionButton(player)
			player.normalspeed = 5 * FRACUNIT
		end
		player.mo.state = S_PLAY_WALK
	end
end

//hooks
addHook("PlayerThink", CrawlAndSlide)