local CrashSkinCheck = CrashAddon.CrashSkinCheck
local JumpManager = CrashAddon.JumpManager

/*has its own version of the ActionButton function since the spin move is on
different button from crawl/slide and body slam*/
local function ActionButton(player)
	if player.crash_consolemode
		return BT_SPIN
	else
		return BT_CUSTOM1
	end
end

local function TornadoSpinGlide(player)
	if not CrashSkinCheck(player)
		return
	end
	
	if player.crashban.spincooldown <= 0
		//this makes crash start spinning when the button is pressed
		if player.cmd.buttons & ActionButton(player)
			if not player.crashban.buttonpress
				if player.crashban.glidecounter < 10
					player.crashban.spintimer = TICRATE / 2
					S_StartSound(player.mo, sfx_cshspn)
					if P_IsObjectOnGround(player.mo) or player.mo.eflags &
							MFE_JUSTHITFLOOR
						player.crashban.glidecounter = 10
					else
						player.crashban.glidecounter = $ + 1
					end
				end
				player.crashban.buttonpress = true
			end
		else
			player.crashban.buttonpress = false
		end
		//this makes crash spin and glide while the spin move is active
		if player.crashban.spintimer > 0
			if player.mo.state != S_PLAY_SPINDASH
				player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_WALL
				player.mo.state = S_PLAY_SPINDASH
			end
			local speen
			if speen == nil
				speen = player.drawangle
			end
			speen = $ + ANGLE_22h
			player.drawangle = FixedAngle(speen)
			if not P_IsObjectOnGround(player.mo) and (player.mo.eflags & 
					MFE_VERTICALFLIP and player.mo.momz > 0) or (not 
					(player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz < 0)
				JumpManager(player.mo, -3 * FRACUNIT)
			end
			player.crashban.spintimer = $ - 1
		else
			if player.mo.state == S_PLAY_SPINDASH
				player.mo.state = S_PLAY_WALK
				player.crashban.spincooldown = 2 * TICRATE
			end
		end
	else
		if player.mo.state == S_PLAY_SPINDASH
			player.mo.state = S_PLAY_WALK
		end
		player.crashban.glidecounter = 0
		player.crashban.spincooldown = $ - 3
	end
end

//hooks
addHook("PlayerThink", TornadoSpinGlide)